Unit ZF12C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZF10_p;

procedure ZF12C(F :Func_F1C; K :Integer; NG :Integer; N :Integer;
                EPS :Real; NDIG :Integer; var CROOT :Array of Complex;
                var ITER :Array of Integer; ITMAX :Integer;
                var IERR :Integer);

implementation

procedure ZF12C(F :Func_F1C; K :Integer; NG :Integer; N :Integer;
                EPS :Real; NDIG :Integer; var CROOT :Array of Complex;
                var ITER :Array of Integer; ITMAX :Integer;
                var IERR :Integer);
var
I,IC,ICK,JK,KN,KNP1,KNPN,KNPNG,L,LM1,NN,NSIG,NGUESS :Integer;
QZ,EPS1,R1 :Real;
D,DD,DEN,FPRT,FRT,H,RT,T1,T2,T3,TEM,Z0,Z1,Z2,BI,XX,XL,Y0,Y1,Y2,X0,
   ZERO,P1,ONE,FOUR,P5 :Complex;
const
RZERO :Real = 0.0;
RTEN :Real = 10.0;
RHUN :Real = 100.0;
RP01 :Real = 0.01;
AX :Real = 0.1;
ICKMAX :Integer = 3;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19;
begin
ZERO := Cmplx(0.0,0.0);
P1 := Cmplx(0.1,0.0);
ONE := Cmplx(1.0,0.0);
FOUR := Cmplx(4.0,0.0);
P5 := Cmplx(0.5,0.0);
NSIG := NDIG;
KN := K;
NGUESS := NG;
IERR := 0;
if ( N < 1 )
 then goto _19;
if ( NDIG = 0 ) and ( EPS = 0.0 ) 
 then NSIG := 5;
EPS1 := Power(RTEN,-NSIG);
EPS1 := EMin1(EPS1,RP01);
KNP1 := KN+1;
KNPN := KN+N;
KNPNG := KN+NGUESS;
R1 := EPS1;
if ( EPS1 <= 1.E-5 ) 
 then R1 := 1.E-5;
for I:=1 to KNPN do
 begin
  ITER[I-1] := 0;
  if ( I > KNPNG ) 
   then CROOT[I-1] := ZERO;
_1:
 end;
L := KNP1;
_2:
JK := 0;
ICK := 0;
XL := CROOT[L-1];
_3:
IC := 0;
H := Cmplx(AX,0.0);
H := MulC(P1,H);
if ( Cabs(XL) > AX ) 
 then H := MulC(P1,XL);
RT := AddC(XL,H);
NN := 4;
goto _11;
_4:
Z0 := FPRT;
Y0 := FRT;
X0 := RT;
RT := SubC(XL,H);
NN := 5;
goto _11;
_5:
Z1 := FPRT;
Y1 := FRT;
H := SubC(XL,RT);
D := DivC(H,SubC(RT,X0));
RT := XL;
NN := 6;
goto _11;
_6:
Z2 := FPRT;
Y2 := FRT;
_7:
DD := AddC(ONE,D);
T1 := MulC(MulC(Z0,D),D);
T2 := MulC(MulC(Z1,DD),DD);
XX := MulC(Z2,DD);
T3 := MulC(Z2,D);
BI := AddC(AddC(SubC(T1,T2),XX),T3);
DEN := SubC(MulC(BI,BI),MulC(FOUR,SubC(MulC(XX,T1),MulC(T3,SubC(T2,XX)))));
T1 := Csqrt(DEN);
QZ := RHUN*EMax1(Cabs(BI),Cabs(T1));
T2 := AddC(BI,T1);
if ( Cabs(T2)+QZ = QZ ) 
 then T2 := ZERO;
T3 := SubC(BI,T1);
if ( Cabs(T3)+QZ = QZ ) 
 then T3 := ZERO;
DEN := T2;
QZ := Cabs(T3)-Cabs(T2);
if ( QZ > RZERO ) 
 then DEN := T3;
NN := 6;
if ( Cabs(DEN) = RZERO ) 
 then goto _14;
D := DivC(SubC(Cmplx(0.0,0.0),XX),DEN);
D := AddC(D,D);
H := MulC(D,H);
RT := AddC(RT,H);
if ( NSIG = 0 ) 
 then goto _8;
if ( Cabs(H) <= EPS1*EMax1(Cabs(RT),AX) ) 
 then goto _16;
if ( IC <> 0 ) 
 then goto _3;
_8:
NN := 9;
goto _11;
_9:
QZ := Cabs(FPRT)-Cabs(Z2)*RTEN;
if ( QZ >= RZERO ) 
 then goto _10;
Z0 := Z1;
Z1 := Z2;
Z2 := FPRT;
Y0 := Y1;
Y1 := Y2;
Y2 := FRT;
goto _7;
_10:
D := MulC(D,P5);
H := MulC(H,P5);
RT := SubC(RT,H);
_11:
JK := JK+1;
if ( JK > ITMAX ) 
 then goto _17;
FRT := F(RT);
FPRT := FRT;
if ( L = 1 ) 
 then goto _15;
LM1 := L-1;
for I:=1 to LM1 do
 begin
  TEM := SubC(RT,CROOT[I-1]);
  if ( Cabs(TEM) < 1.E-4 ) 
   then goto _14;
_12:
  FPRT := DivC(FPRT,TEM);
 end;
_13:
if ( Cabs(FPRT) <= Abs(EPS) ) and ( Cabs(FRT) <= Abs(EPS) )
 then goto _18;
if ( NN=4 ) then goto _4 else
if ( NN=5 ) then goto _5 else
if ( NN=6 ) then goto _6 else
if ( NN=9 ) then goto _9;
_14:
if ( IC <> 0 ) 
 then goto _3;
TEM := Cmplx(RTEN*R1,0.0);
if ( Cabs(RT) > AX ) 
 then TEM := MulC(TEM,RT);
RT := AddC(RT,TEM);
D := DivC(MulC((AddC(H,TEM)),D),H);
H := AddC(H,TEM);
goto _11;
_15:
if ( Cabs(RT) < 1.E-4 ) 
 then goto _14;
FPRT := DivC(FPRT,RT);
goto _13;
_16:
if ( IC <> 0 ) 
 then goto _18;
IC := 1;
Z0 := Y1;
Z1 := Y2;
Z2 := F(RT);
XL := RT;
ICK := ICK+1;
if ( ICK <= ICKMAX ) 
 then goto _7;
JK := ITMAX+JK;
_17:
IERR := 1;
_18:
CROOT[L-1] := RT;
ITER[L-1] := JK;
L := L+1;
if ( L <= KNPN ) 
 then goto _2;
if ( IERR = 0 ) 
 then goto _19;
UTZF10(IERR,12);
_19:
end;

end.
